////////////////////////////////////////////////////////////////////////
// recordings.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.recordings")

// <%pre>
#line 1 "recordings.ecpp"


#include <setup.h>
#include <tasks.h>
#include <tools.h>
#include <users.h>
#include <recman.h>
#include <tntconfig.h>
#ifdef HAVE_PCRE2
#include <StringMatch.h>
#endif
#include <vdr/videodir.h>

#define MB_PER_MINUTE 25.75 // this is just an estimate!
#include <string>
std::string argList;
std::string recoring_item;
size_t max_length_recoring_item = 0;

using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class recordings_item_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        recordings_item_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class sort_options_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        sort_options_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class del_rec_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        del_rec_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class edit_rec_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        edit_rec_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class rec_tools_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        rec_tools_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class archived_disc_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        archived_disc_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class delete_error_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        delete_error_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    recordings_item_type recordings_item;
    sort_options_type sort_options;
    del_rec_type del_rec;
    edit_rec_type edit_rec;
    rec_tools_type rec_tools;
    archived_disc_type archived_disc;
    delete_error_type delete_error;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("recordings");

static const char* rawData = "\350\001\000\000\351\001\000\000\352\001\000\000\353\001\000\000\017\002\000\000\032\002"
  "\000\000\035\002\000\0002\003\000\000\215\003\000\000\255\004\000\000\276\004\000\000\003\010\000\000\247\010\000\000"
  "\007\t\000\000\311\015\000\000\356\016\000\000\031\017\000\000W\017\000\000\277\017\000\000\037\021\000\000Z\023\000"
  "\000\254\023\000\000\035\024\000\000m\024\000\000\232\026\000\000\360\034\000\000\361\034\000\000\363\034\000\000\364"
  "\034\000\000\366\034\000\000\367\034\000\0002\035\000\000E\035\000\000H\035\000\000I\035\000\000\337\035\000\0005\036"
  "\000\000T\036\000\000n\036\000\000o\036\000\000p\036\000\000r\036\000\000\352\036\000\000\020\037\000\000%\037\000"
  "\000O\037\000\000~\037\000\000\236\037\000\000\324\037\000\000\341\037\000\000\375\037\000\000\? \000\000A \000\000"
  "\223 \000\000\252 \000\000\337 \000\000\020!\000\000%!\000\000(!\000\000+!\000\0003!\000\0007!\000\000H!\000\000\355!"
  "\000\000\034\"\000\000\177\"\000\000\347\"\000\0009#\000\000M#\000\000Y#\000\000\220#\000\000\221#\000\000\223#\000"
  "\000\254#\000\000\337#\000\000\343#\000\000-$\000\0001$\000\000\201$\000\000\205$\000\000\212$\000\000\321$\000\000"
  "\325$\000\000\332$\000\000\016%\000\000=%\000\000u%\000\000}%\000\000\270%\000\000\301%\000\000\346%\000\000\357%\000"
  "\000\371%\000\000\372%\000\000\374%\000\000\033&\000\000\035&\000\000(&\000\0007&\000\0008&\000\000:&\000\000]&\000"
  "\000i&\000\000r&\000\000y&\000\000z&\000\000}&\000\000~&\000\000\177&\000\000\200&\000\000\201&\000\000\202&\000\000"
  "\203&\000\000\205&\000\000\217&\000\000\236&\000\000\242&\000\000\243&\000\000\244&\000\000\246&\000\000\250&\000\000"
  "\251&\000\000\n\n\n\n<html>\n\t<head>\n\t\t<title>VDR-Live - </title>\n\t\t\n\t\t\n<script>\nfunction RecordingAction"
  "(id, A, Img, Title, argList) {\n  document.write('<a href=\"')\n  document.write(A)\n  document.write('recording_')\n"
  "  document.write(id)\n  document.write(argList)\n  document.write('\" title=\"')\n  document.write(Title)\n  document"
  ".write('\"><img src=\"')\n  document.write(Img)\n  document.write('\" /></a>')\n}\nfunction IMDB(im_db, name) {\n  if"
  " ( != 0) {\n    if (im_db == \"\") {\n      document.write('<a href=\"http://www.imdb.com/find\?s=all&q=')\n      doc"
  "ument.write(name)\n    } else {\n      document.write('<a href=\"https://www.imdb.com/title/')\n      document.write("
  "im_db)\n    }\n    document.write(\n     '\" target=\"_blank\"><img src=\"imdb.png\" title=\"\"/></a>')\n  }\n}\n// ["
  "0] : IMDB ID\n// [1] : ID (prefix \"recording_\" removed !!!)\n// [2] : ArchiveDescr()\n// [3] : image.path  (nach \""
  "/tvscraper/\") \n// [4] : \"pt\" if m_s_image.width <= m_s_image.height, otherwise= \"\"\n// [5] : title (scraper)\n/"
  "/ [6] : season / episode (scraper, for tv shows, if available. Otherwise: Empty)\n// [7] : runtime (scraper)\n// [8] "
  ": relase date (scraper)\n// [9] : recording_spec: Day, time & duration\n// [10] : Number of recording errors\n\nfunct"
  "ion Recordings(level, argList, displayFolder, data) {\n  for (obj of data) {\n    document.write(\n      '<li class="
  "\"recording\"><div class=\"recording_item\"><div class=\"recording_imgs\">')\n    if (level > 0) document.write(\n   "
  "   '<img src=\"img/transparent.png\" width=\"' + String(16 * level) + 'px\" height=\"16px\" />')\n    if (obj[2] != "
  "\"\") {\n      document.write('<img src=\"on_dvd.png\" alt=\"on_dvd\" title=\"')\n      document.write(obj[2])\n     "
  " document.write('/>')\n    } else {\n      document.write('<input type=\"checkbox\" name=\"deletions\" value=\"record"
  "ing_');\n      document.write(obj[1])\n      document.write('\" />')\n    }\n    if (\"\" != \"\") {\n      document."
  "write('</div><div class=\"thumb\"><a class=\"thumb\" href=\"epginfo.html\?epgid=recording_')\n      document.write(ob"
  "j[1])\n      document.write('\"><img src=\"')\n      if (obj[3] != \"\") {\n        document.write('/tvscraper/')\n  "
  "      document.write(obj[3])\n        document.write('\" class=\"thumb')\n        document.write(obj[4])\n      } els"
  "e document.write('img/transparent.png\" height=\"16px')\n      if (obj[5] != \"\" || obj[8] != \"\") {\n// scraper da"
  "ta available\n        document.write('\" title=\"')\n        document.write(obj[5])\n          if (obj[6] != \"\") {"
  "\n            document.write('<br/>S')\n            document.write(obj[6])\n          }\n          if (obj[7] != \"\""
  ") {\n            document.write('<br/>')\n            document.write(obj[7])\n          }\n          if (obj[8] != \""
  "\") {\n            document.write('<br/>')\n            document.write(obj[8])\n          }\n      }\n      document."
  "write('\"/> </a>')\n    }\n// end if (!LiveSetup().GetTvscraperImageDir().empty() )\n    document.write('</div><div c"
  "lass=\"recording_spec\"><div class=\"recording_day\">')\n    document.write(obj[9])\n    document.write('</div>')\n  "
  "  if (obj[10] > -100) {\n      document.write('<div class=\"recording_errors\"><img src=\"')\n      if (obj[10] == 0)"
  " document.write('NoRecordingErrors.png')\n      if (obj[10]  > 0) document.write('RecordingErrors.png')\n      if (ob"
  "j[10]  < 0) document.write('NotCheckedForRecordingErrors.png')\n      document.write('\" width = \"16px\" title=\"')"
  "\n      if (obj[10] == 0) document.write('')\n      if (obj[10]  > 0) document.write(' ' + String(obj[10]))\n      if"
  " (obj[10]  < 0) document.write('')\n      document.write('\" /> </div>')\n    }\n    document.write('<div class=\"rec"
  "ording_sd_hd\"><img src=\"')\n    document.write(obj[11])\n    document.write('d.png\" width = \"25px\" title=\"')\n "
  "   document.write(obj[12])\n    document.write('\" /> </div><div class=\"recording_name')\n    document.write(obj[13]"
  ")\n    document.write('\"><a title=\"')\n    if (obj[14] != \"\") {\n      document.write(obj[14])\n      document.wr"
  "ite('&lt;br /&gt;')\n    }\n    document.write('')\n    document.write('\" href=\"epginfo.html\?epgid=recording_')\n "
  "   document.write(obj[1])\n    document.write('\">')\n    document.write(obj[15])\n    if (displayFolder == 1 && obj["
  "16] != \"\") {\n      document.write(' (')\n      document.write(obj[16])\n      document.write(')')\n    }\n    docu"
  "ment.write('<br /><span>')\n    document.write(obj[14])\n    if (obj[14] == \"\") document.write('&nbsp;')\n    docum"
  "ent.write('</span></a></div></div><div class=\"recording_actions\">')\n    if (obj[2] == \"\") {\n      RecordingActi"
  "on(obj[1], \"vdr_request/play_recording\?param=\", \"play.png\", \"\", argList)\n      RecordingAction(obj[1], \"play"
  "list.m3u\?recid=\", \"playlist.png\", \"\", argList)\n      IMDB(obj[0], obj[15])\n      RecordingAction(obj[1], \"ed"
  "it_recording.html\?recid=\", \"edit.png\", \"\", argList)\n      RecordingAction(obj[1], \"recordings.html\?todel=\","
  " \"del.png\", \"\", argList)\n    } else {\n      document.write('<img src=\"img/transparent.png\" width=\"16px\" hei"
  "ght=\"16px\" />')\n      IMDB(obj[0], obj[15])\n    }\n    document.write('</div>')\n    if (obj[2] != \"\") {\n     "
  " document.write('<div class=\"recording_arch\">')\n      document.write(obj[2])\n      document.write('</div>')\n    "
  "}\n    document.write('</div></li>')\n  }\n}\n</script>\n\n\n\n\n\t\t<script type=\"text/javascript\" src=\"treeview."
  "js\"></script>\n\t\t<script type=\"text/javascript\"><!--\n\t\tfunction filterRecordings(filter)\n\t\t{\n\t\t\twindow"
  ".location.href = \"recordings.html\?sort=&filter=\" + encodeURIComponent(filter.value);\n\t\t}\n\t\tfunction ExpandAl"
  "l()\n\t\t{\n\t\t\tvar openNodes = \"\";\n\t\t\trecordingNodes = window.document.getElementsBySelector(\"ul.recordings"
  "list\");\n\t\t\tfor (idx = 0; idx < recordingNodes.length; idx++) {\n\t\t\t\tif (recordingNodes[idx].parentNode.class"
  "Name != 'recordings') {\n\t\t\t\t\trecordingNodes[idx].style.display = 'block';\n\t\t\t\t\topenNodes += recordingNode"
  "s[idx].id + \",\"; \n\t\t\t\t}\n\t\t\t}\n\t\t\texpandNodes = window.document.getElementsBySelector(\"img.recording_ex"
  "pander\");\n\t\t\tfor (idx = 0; idx < expandNodes.length; idx++) {\n\t\t\t\texpandNodes[idx].src = \"img/minus.png\";"
  "\n\t\t\t}\n\t\t\tfolderNodes = window.document.getElementsBySelector(\"img.recording_folder\");\n\t\t\tfor (idx = 0; "
  "idx < folderNodes.length; idx++) {\n\t\t\t\tfolderNodes[idx].src = \"img/folder_open.png\";\n\t\t\t}\n\t\t\tcreateCoo"
  "kie( cookieNameRec, openNodes, 14 );\n\t\t}\n\t\tfunction CollapseAll()\n\t\t{\n\t\t\trecordingNodes = window.documen"
  "t.getElementsBySelector(\"ul.recordingslist\");\n\t\t\tfor (idx = 0; idx < recordingNodes.length; idx++) {\n\t\t\t\ti"
  "f (recordingNodes[idx].parentNode.className != 'recordings') {\n\t\t\t\t\trecordingNodes[idx].style.display = 'none';"
  "\n\t\t\t\t}\n\t\t\t}\n\t\t\texpandNodes = window.document.getElementsBySelector(\"img.recording_expander\");\n\t\t\tf"
  "or (idx = 0; idx < expandNodes.length; idx++) {\n\t\t\t\texpandNodes[idx].src = \"img/plus.png\";\n\t\t\t}\n\t\t\tfol"
  "derNodes = window.document.getElementsBySelector(\"img.recording_folder\");\n\t\t\tfor (idx = 0; idx < folderNodes.le"
  "ngth; idx++) {\n\t\t\t\tfolderNodes[idx].src = \"img/folder_closed.png\";\n\t\t\t}\n\t\t\teraseCookie( cookieNameRec "
  ");\n\t\t}\n\t\t//--></script>\n\t</head>\n\t<body onload=\"adjustHeader()\" onresize=\"adjustHeader()\">\n\t\t\n\t\t"
  "\n\t\t\n\t\t<div class=\"inhalt\">\n\t\t\t<div class=\"boxheader\"><div><div></div></div></div>\n\t\t\t\n\t\t\t<form "
  "method=\"post\" name=\"recordings\" action=\"recordings.ecpp\">\n\t\t\t<div class=\"recordings\">\n\t\t\t<ul class=\""
  "recordingslist\" style=\"display: block;\">\n\n\t\t\t</ul>\n\t\t\t</div>\n\t\t\t<div class=\"withmargin\">\n\t\t\t\t<"
  "button class=\"red\" type=\"submit\"></button>\n\t\t\t</div>\n\t\t\t</form>\n\t\t</div>\n\t</body>\n</html>\n\n\n\n\n"
  "    <li class=\"recording\">\n    <div class=\"recording_item\" onclick=\"Toggle(this)\">\n    <div class=\"recording"
  "_imgs\">\n    <img src=\"img/transparent.png\" width=\"px\" height=\"16px\" /> \n    <img class=\"recording_expander"
  "\" src=\"plus.png\" /><img class=\"recording_folder\" src=\"folder_closed.png\" /></div>\n    \n      <div class=\"th"
  "umb\">\n      <img src=\"/tvscraper/\"\n           \n      />\n      </div>\n     \n    <div class=\"recording_spec\""
  ">\n      <div class=\"recording_name\"></div>\n    </div>\n    <div class=\"recording_actions\">&nbsp;</div>\n    </d"
  "iv>\n\n              <ul id=\"fldr_\" class=\"recordingslist\" style=\"display: none;\">\n    \n                    <"
  "/ul>\n            </li>\n      <script>Recordings(, \"\", , [\n        \n  ])</script>\n        <li class=\"recording"
  "\">\n      <div class=\"recording_item\" onclick=\"Toggle(this)\">\n      <div class=\"recording_imgs\">\n      <img "
  "class=\"recording_expander\" src=\"plus.png\" /><img class=\"recording_folder\" src=\"folder_closed.png\" /></div>\n "
  "     <div class=\"recording_spec\">\n        <div class=\"recording_name\"></div>\n      </div>\n      <div class=\"r"
  "ecording_actions\">&nbsp;</div>\n      </div>\n        <ul id=\"fldr_\" class=\"recordingslist\" style=\"display: non"
  "e;\">\n          <script>Recordings(1, \"\", 1, [\n                        \n          ])</script>\n        </ul>\n  "
  "    </li>\n      \n\n\n<span class=\"label bold\"> </span>\n<a href=\"recordings.html\?sort=name&filter=\" /></a>\n<s"
  "pan class=\"sep\">|</span>\n<a href=\"recordings.html\?sort=date&filter=\" /></a>\n<span class=\"sep\">|</span>\n<a h"
  "ref=\"recordings.html\?sort=duplicates&filter=\" /></a>\n<span class=\"sep\">|</span>\n<a href=\"recordings.html\?sor"
  "t=errors&filter=\" /></a>\n<span class=\"sep\">|</span>\n<span class=\"label bold\">:&nbsp;<input type=\"text\" name="
  "\"filter\" value=\"\" id=\"filter\" onchange=\"filterRecordings(this)\" />&nbsp;</span>\n<span class=\"sep\">|</span>"
  "\n<img onclick=\"ExpandAll()\" src=\"\" alt=\"\" />\n<img onclick=\"CollapseAll()\" src=\"\" alt=\"\" />\n<br />\n\n"
  "\n\n<a href=\"recordings.html\?todel=\" ><img src=\"\" alt=\"\" /></a>\n\n\n<a href=\"edit_recording.html\?recid=\"><"
  "img src=\"\" alt=\"\"  /></a>\n\n\n\n\n\n\n\n\n\n\n\n<img src=\"\" alt=\"on_dvd\"  />\n\n\n\n\n\n\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    recordings_item(*this, "recordings_item"),
    sort_options(*this, "sort_options"),
    del_rec(*this, "del_rec"),
    edit_rec(*this, "edit_rec"),
    rec_tools(*this, "rec_tools"),
    archived_disc(*this, "archived_disc"),
    delete_error(*this, "delete_error")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string sort = qparam.get< std::string >("sort");
std::string todel = qparam.get< std::string >("todel");
std::string diskinfo = qparam.get< std::string >("diskinfo");
std::string filter = qparam.get< std::string >("filter");
std::vector< std::string > deletions = qparam.getvector< std::string >("deletions");
std::string flat = qparam.get< std::string >("flat");
  // </%args>

#line 32 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 37 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 38 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 39 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 40 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[0]; // \n
  reply.out() << _tntChunks[1]; // \n
  reply.out() << _tntChunks[2]; // \n
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 44 "recordings.ecpp"

if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

// sort depends on old sort, an sort parameter
currentSort = LiveSetup().GetLastSortingMode();
if (currentSort.empty() ) currentSort = "nameasc";
if (!sort.empty()) {
	if (sort == "date")
		currentSort = (currentSort == "dateasc") ? "datedesc" : "dateasc";
	else if (sort == "name")
		currentSort = (currentSort == "nameasc") ? "namedesc" : "nameasc";
	else if (sort == "errors")
                currentSort = (currentSort == "errorsasc") ? "errorsdesc" : "errorsasc";
	else if (sort == "duplicates")
		currentSort = sort;
	else if (sort == "tvShowsMovies")
		currentSort = sort;
	LiveSetup().SetLastSortingMode(currentSort);
}
// flat defaults from sort, but can we overwritten
if (currentSort == "errorsasc" || currentSort == "errorsdesc" || currentSort == "duplicates") currentFlat = "true";
  else currentFlat = "false";
if (! flat.empty() ) currentFlat = flat;

currentFilter = filter;

pageTitle = tr("Recordings");

deleteResult = "";
if (!todel.empty()) {
	if (!cUser::CurrentUserHasRightTo(UR_DELRECS))
		throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
	deletions.push_back(todel);
}
#if TNTVERSION >= 30000
typedef std::vector<std::string> deletions_type;
#endif
for (deletions_type::const_iterator it = deletions.begin(); it != deletions.end(); ++it) {
	if (cUser::CurrentUserHasRightTo(UR_DELRECS)) {
		RemoveRecordingTask task(*it);
		LiveTaskManager().Execute(task);
		if (!task.Result())
			deleteResult += std::string() + tr("ERROR:") + " " + task.Error() + "<br/>";
		else
			deleteResult += std::string() + tr("Deleted recording:") + " " + StringReplace(task.RecName(), "~", "/") + "<br/>";
	}
	else {
		throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
	}
}
deletions.clear();

int FreeMB, UsedMB;
#if APIVERSNUM > 20101
int Percent = cVideoDirectory::VideoDiskSpace(&FreeMB, &UsedMB);
#else
int Percent = VideoDiskSpace(&FreeMB, &UsedMB);
#endif
int Minutes = int(double(FreeMB) / MB_PER_MINUTE);
int Hours = Minutes / 60;
Minutes %= 60;
diskinfo = cString::sprintf("%s %d%%  -  %2d:%02d %s", trVDR("Disk"), Percent, Hours, Minutes, trVDR("free"));
#if TNTVERSION >= 30000                                                                                                                       
std::string TNT_ARRAY  = "[]";
#else                                                                                                                                         
std::string TNT_ARRAY = "";
#endif                                                                                                                                        
                                                                                                                                              

  // <& pageelems.doc_type ...
  { 
#line 113 "recordings.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 113 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n<html>\n\t<head>\n\t\t<title>VDR-Live - 
#line 116 "recordings.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[4]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 117 "recordings.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 117 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 118 "recordings.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 118 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[6]; // \n<script>\nfunction RecordingAction(id, A, Img, Title, argList) {\n  document.write('<a href="')\n  document.write(A)\n  document.write('recording_')\n  document.write(id)\n  document.write(argList)\n  document.write('" title="')\n  document.write(Title)\n  document.write('"><img src="
#line 128 "recordings.ecpp"
  reply.sout() << (LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[7]; // ')\n  document.write(Img)\n  document.write('" /></a>')\n}\nfunction IMDB(im_db, name) {\n  if (
#line 133 "recordings.ecpp"
  reply.sout() << (LiveSetup().GetShowIMDb());
  reply.out() << _tntChunks[8]; //  != 0) {\n    if (im_db == "") {\n      document.write('<a href="http://www.imdb.com/find\?s=all&q=')\n      document.write(name)\n    } else {\n      document.write('<a href="https://www.imdb.com/title/')\n      document.write(im_db)\n    }\n    document.write(\n     '" target="_blank"><img src="
#line 142 "recordings.ecpp"
  reply.sout() << (LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[9]; // imdb.png" title="
#line 142 "recordings.ecpp"
  reply.sout() << (tr("Find more at the Internet Movie Database."));
  reply.out() << _tntChunks[10]; // "/></a>')\n  }\n}\n// [0] : IMDB ID\n// [1] : ID (prefix "recording_" removed !!!)\n// [2] : ArchiveDescr()\n// [3] : image.path  (nach "/tvscraper/") \n// [4] : "pt" if m_s_image.width <= m_s_image.height, otherwise= ""\n// [5] : title (scraper)\n// [6] : season / episode (scraper, for tv shows, if available. Otherwise: Empty)\n// [7] : runtime (scraper)\n// [8] : relase date (scraper)\n// [9] : recording_spec: Day, time & duration\n// [10] : Number of recording errors\n\nfunction Recordings(level, argList, displayFolder, data) {\n  for (obj of data) {\n    document.write(\n      '<li class="recording"><div class="recording_item"><div class="recording_imgs">')\n    if (level > 0) document.write(\n      '<img src="img/transparent.png" width="' + String(16 * level) + 'px" height="16px" />')\n    if (obj[2] != "") {\n      document.write('<img src="
#line 164 "recordings.ecpp"
  reply.sout() << (LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[11]; // on_dvd.png" alt="on_dvd" title="')\n      document.write(obj[2])\n      document.write('/>')\n    } else {\n      document.write('<input type="checkbox" name="deletions
#line 168 "recordings.ecpp"
  reply.sout() << (TNT_ARRAY);
  reply.out() << _tntChunks[12]; // " value="recording_');\n      document.write(obj[1])\n      document.write('" />')\n    }\n    if ("
#line 172 "recordings.ecpp"
  reply.sout() << (LiveSetup().GetTvscraperImageDir());
  reply.out() << _tntChunks[13]; // " != "") {\n      document.write('</div><div class="thumb"><a class="thumb" href="epginfo.html\?epgid=recording_')\n      document.write(obj[1])\n      document.write('"><img src="')\n      if (obj[3] != "") {\n        document.write('/tvscraper/')\n        document.write(obj[3])\n        document.write('" class="thumb')\n        document.write(obj[4])\n      } else document.write('img/transparent.png" height="16px')\n      if (obj[5] != "" || obj[8] != "") {\n// scraper data available\n        document.write('" title="')\n        document.write(obj[5])\n          if (obj[6] != "") {\n            document.write('<br/>S')\n            document.write(obj[6])\n          }\n          if (obj[7] != "") {\n            document.write('<br/>')\n            document.write(obj[7])\n          }\n          if (obj[8] != "") {\n            document.write('<br/>')\n            document.write(obj[8])\n          }\n      }\n      document.write('"/> </a>')\n    }\n// end if (!LiveSetup().GetTvscraperImageDir().empty() )\n    document.write('</div><div class="recording_spec"><div class="recording_day">')\n    document.write(obj[9])\n    document.write('</div>')\n    if (obj[10] > -100) {\n      document.write('<div class="recording_errors"><img src="
#line 206 "recordings.ecpp"
  reply.sout() << (LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[14]; // ')\n      if (obj[10] == 0) document.write('NoRecordingErrors.png')\n      if (obj[10]  > 0) document.write('RecordingErrors.png')\n      if (obj[10]  < 0) document.write('NotCheckedForRecordingErrors.png')\n      document.write('" width = "16px" title="')\n      if (obj[10] == 0) document.write('
#line 211 "recordings.ecpp"
  reply.sout() << (tr("No recording errors"));
  reply.out() << _tntChunks[15]; // ')\n      if (obj[10]  > 0) document.write('
#line 212 "recordings.ecpp"
  reply.sout() << (tr("Number of recording errors:"));
  reply.out() << _tntChunks[16]; //  ' + String(obj[10]))\n      if (obj[10]  < 0) document.write('
#line 213 "recordings.ecpp"
  reply.sout() << (tr("Recording errors unknown"));
  reply.out() << _tntChunks[17]; // ')\n      document.write('" /> </div>')\n    }\n    document.write('<div class="recording_sd_hd"><img src="
#line 216 "recordings.ecpp"
  reply.sout() << (LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[18]; // ')\n    document.write(obj[11])\n    document.write('d.png" width = "25px" title="')\n    document.write(obj[12])\n    document.write('" /> </div><div class="recording_name')\n    document.write(obj[13])\n    document.write('"><a title="')\n    if (obj[14] != "") {\n      document.write(obj[14])\n      document.write('&lt;br /&gt;')\n    }\n    document.write('
#line 227 "recordings.ecpp"
  reply.sout() << (tr("Click to view details."));
  reply.out() << _tntChunks[19]; // ')\n    document.write('" href="epginfo.html\?epgid=recording_')\n    document.write(obj[1])\n    document.write('">')\n    document.write(obj[15])\n    if (displayFolder == 1 && obj[16] != "") {\n      document.write(' (')\n      document.write(obj[16])\n      document.write(')')\n    }\n    document.write('<br /><span>')\n    document.write(obj[14])\n    if (obj[14] == "") document.write('&nbsp;')\n    document.write('</span></a></div></div><div class="recording_actions">')\n    if (obj[2] == "") {\n      RecordingAction(obj[1], "vdr_request/play_recording\?param=", "play.png", "
#line 242 "recordings.ecpp"
  reply.sout() << (tr("play this recording"));
  reply.out() << _tntChunks[20]; // ", argList)\n      RecordingAction(obj[1], "playlist.m3u\?recid=", "playlist.png", "
#line 243 "recordings.ecpp"
  reply.sout() << (tr("Stream this recording into media player."));
  reply.out() << _tntChunks[21]; // ", argList)\n      IMDB(obj[0], obj[15])\n      RecordingAction(obj[1], "edit_recording.html\?recid=", "edit.png", "
#line 245 "recordings.ecpp"
  reply.sout() << (tr("Edit recording"));
  reply.out() << _tntChunks[22]; // ", argList)\n      RecordingAction(obj[1], "recordings.html\?todel=", "del.png", "
#line 246 "recordings.ecpp"
  reply.sout() << (tr("Delete this recording from hard disc!"));
  reply.out() << _tntChunks[23]; // ", argList)\n    } else {\n      document.write('<img src="img/transparent.png" width="16px" height="16px" />')\n      IMDB(obj[0], obj[15])\n    }\n    document.write('</div>')\n    if (obj[2] != "") {\n      document.write('<div class="recording_arch">')\n      document.write(obj[2])\n      document.write('</div>')\n    }\n    document.write('</div></li>')\n  }\n}\n</script>\n\n\n\n\n\t\t<script type="text/javascript" src="treeview.js"></script>\n\t\t<script type="text/javascript"><!--\n\t\tfunction filterRecordings(filter)\n\t\t{\n\t\t\twindow.location.href = "recordings.html\?sort=
#line 269 "recordings.ecpp"
  reply.sout() << ( currentSort );
  reply.out() << _tntChunks[24]; // &filter=" + encodeURIComponent(filter.value);\n\t\t}\n\t\tfunction ExpandAll()\n\t\t{\n\t\t\tvar openNodes = "";\n\t\t\trecordingNodes = window.document.getElementsBySelector("ul.recordingslist");\n\t\t\tfor (idx = 0; idx < recordingNodes.length; idx++) {\n\t\t\t\tif (recordingNodes[idx].parentNode.className != 'recordings') {\n\t\t\t\t\trecordingNodes[idx].style.display = 'block';\n\t\t\t\t\topenNodes += recordingNodes[idx].id + ","; \n\t\t\t\t}\n\t\t\t}\n\t\t\texpandNodes = window.document.getElementsBySelector("img.recording_expander");\n\t\t\tfor (idx = 0; idx < expandNodes.length; idx++) {\n\t\t\t\texpandNodes[idx].src = "img/minus.png";\n\t\t\t}\n\t\t\tfolderNodes = window.document.getElementsBySelector("img.recording_folder");\n\t\t\tfor (idx = 0; idx < folderNodes.length; idx++) {\n\t\t\t\tfolderNodes[idx].src = "img/folder_open.png";\n\t\t\t}\n\t\t\tcreateCookie( cookieNameRec, openNodes, 14 );\n\t\t}\n\t\tfunction CollapseAll()\n\t\t{\n\t\t\trecordingNodes = window.document.getElementsBySelector("ul.recordingslist");\n\t\t\tfor (idx = 0; idx < recordingNodes.length; idx++) {\n\t\t\t\tif (recordingNodes[idx].parentNode.className != 'recordings') {\n\t\t\t\t\trecordingNodes[idx].style.display = 'none';\n\t\t\t\t}\n\t\t\t}\n\t\t\texpandNodes = window.document.getElementsBySelector("img.recording_expander");\n\t\t\tfor (idx = 0; idx < expandNodes.length; idx++) {\n\t\t\t\texpandNodes[idx].src = "img/plus.png";\n\t\t\t}\n\t\t\tfolderNodes = window.document.getElementsBySelector("img.recording_folder");\n\t\t\tfor (idx = 0; idx < folderNodes.length; idx++) {\n\t\t\t\tfolderNodes[idx].src = "img/folder_closed.png";\n\t\t\t}\n\t\t\teraseCookie( cookieNameRec );\n\t\t}\n\t\t//--></script>\n\t</head>\n\t<body onload="adjustHeader()" onresize="adjustHeader()">\n\t\t
  // <& pageelems.logo ...
  { 
#line 312 "recordings.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 312 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[25]; // \n
#line 313 "recordings.ecpp"

if (!deleteResult.empty()) {

  reply.out() << _tntChunks[26]; // \t\t
  // <& menu ...
  { 
#line 316 "recordings.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 316 "recordings.ecpp"
    _tnt_cq4.add( "active", ("recordings"));
#line 316 "recordings.ecpp"
    _tnt_cq4.add( "component", ("recordings.delete_error"));
#line 316 "recordings.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[27]; // \n
#line 317 "recordings.ecpp"

} else {

  reply.out() << _tntChunks[28]; // \t\t
  // <& menu ...
  { 
#line 320 "recordings.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 320 "recordings.ecpp"
    _tnt_cq5.add( "active", ("recordings"));
#line 320 "recordings.ecpp"
    _tnt_cq5.add( "component", ("recordings.sort_options"));
#line 320 "recordings.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[29]; // \n
#line 321 "recordings.ecpp"

}

  reply.out() << _tntChunks[30]; // \t\t<div class="inhalt">\n\t\t\t<div class="boxheader"><div><div>
#line 325 "recordings.ecpp"
  reply.sout() << ( std::string(tr("List of recordings")) + " (" + diskinfo + ")" );
  reply.out() << _tntChunks[31]; // </div></div></div>\n
#line 326 "recordings.ecpp"

#if VDRVERSNUM >= 20301
			int rec_cnt;
			{
				LOCK_RECORDINGS_READ;
				rec_cnt = Recordings->Count();  // Access VDRs global cRecordings Recordings instance.
			}
			if (rec_cnt == 0) {
#else
			if (Recordings.Count() == 0) { // Access VDRs global cRecordings Recordings instance.
#endif

  reply.out() << _tntChunks[32]; // \t\t\t
#line 338 "recordings.ecpp"
  reply.sout() << ( tr("No recordings found") );
  reply.out() << _tntChunks[33]; // \n
#line 339 "recordings.ecpp"

			} else {

  reply.out() << _tntChunks[34]; // \t\t\t<form method="post" name="recordings" action="recordings.ecpp">\n\t\t\t<div class="recordings">\n\t\t\t<ul class="recordingslist" style="display: block;">\n
  // <& recordings.recordings_item ...
  { 
#line 345 "recordings.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 345 "recordings.ecpp"
    _tnt_cq6.add( "filter", (currentFilter));
#line 345 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "recordings_item"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[35]; // \n\t\t\t</ul>\n\t\t\t</div>\n\t\t\t<div class="withmargin">\n\t\t\t\t<button class="red" type="submit">
#line 349 "recordings.ecpp"
  reply.sout() << ( tr("Delete selected") );
  reply.out() << _tntChunks[36]; // </button>\n\t\t\t</div>\n\t\t\t</form>\n
#line 352 "recordings.ecpp"

			}

  reply.out() << _tntChunks[37]; // \t\t</div>\n\t</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[38]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[39]; // \n
  reply.out() << _tntChunks[40]; // \n\n
  reply.out() << _tntChunks[70]; // \n
  reply.out() << _tntChunks[71]; // \n\n
  reply.out() << _tntChunks[92]; // \n
  reply.out() << _tntChunks[93]; // \n\n
  reply.out() << _tntChunks[98]; // \n
  reply.out() << _tntChunks[99]; // \n\n
  reply.out() << _tntChunks[104]; // \n
  reply.out() << _tntChunks[105]; // \n\n\n
  reply.out() << _tntChunks[111]; // \n
  reply.out() << _tntChunks[112]; // \n\n
  reply.out() << _tntChunks[117]; // \n
  reply.out() << _tntChunks[118]; // \n\n
  reply.out() << _tntChunks[119]; // \n\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::recordings_item_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::recordings_item " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string filter = qparam.get< std::string >("filter");
int counter = qparam.get< int >("counter", ( 0));
uintptr_t iRecItem = qparam.get< uintptr_t >("iRecItem", ( 0));
  // </%args>

#line 32 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 37 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 38 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 39 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 40 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 368 "recordings.ecpp"

// "
recoring_item.reserve(6000);
// Max Buffer used: 5.636 bytes
RecordingsTreePtr recordingsTree(LiveRecordingsManager()->GetRecordingsTree());
RecordingsItemPtr recItemThisDir;
if (iRecItem != 0) {
recItemThisDir = *(static_cast<RecordingsItemPtr *>((void *)iRecItem) );
} else {
recItemThisDir = recordingsTree->getRoot();
}
std::list<RecordingsItemPtr> recItems;
std::list<RecordingsItemPtr>::iterator recIter;
bool sorted = false;
int level = 0;
if( currentFlat != "true" ) {
// create list of subdirs, in "recItems"
  sorted = recItemThisDir->addSubdirs(recItems);
  if (!sorted) {
    if (currentSort == "namedesc")
      recItems.sort(RecordingsItemPtrCompare::ByDescendingNameDescSort);
    else if (currentSort == "nameasc")
      recItems.sort(RecordingsItemPtrCompare::ByAscendingNameDescSort);
  }
  for (recIter = recItems.begin(); recIter != recItems.end(); ++recIter) {
// this is the loop over the subdirs
    RecordingsItemPtr recItem = *recIter;
    counter++;

    /* search trough directory for new recordings */
    bool newR = false;
    if ( LiveSetup().GetMarkNewRec() ) newR = recItem->checkNew();
    level = recItem->Level();

  reply.out() << _tntChunks[41]; //     <li class="recording">\n    <div class="recording_item" onclick="Toggle(this)">\n    <div class="recording_imgs">\n    
#line 405 "recordings.ecpp"
 if(level > 1) { 
  reply.out() << _tntChunks[42]; // <img src="img/transparent.png" width="
#line 405 "recordings.ecpp"
  reply.sout() << (16*(level-1) );
  reply.out() << _tntChunks[43]; // px" height="16px" /> 
#line 405 "recordings.ecpp"
 } 
  reply.out() << _tntChunks[44]; // \n    <img class="recording_expander" src="
#line 406 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[45]; // plus.png" /><img class="recording_folder" src="
#line 406 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[46]; // folder_closed.png" /></div>\n    
#line 407 "recordings.ecpp"
 if (!recItem->scraperImage().path.empty() ) { 
  reply.out() << _tntChunks[47]; // \n      <div class="thumb">\n      <img src="/tvscraper/
#line 409 "recordings.ecpp"
  reply.sout() << ( recItem->scraperImage().path );
  reply.out() << _tntChunks[48]; // "\n           
#line 410 "recordings.ecpp"
  reply.out() << ( recItem->scraperImage().width > recItem->scraperImage().height?"class=\"thumb\"":"class=\"thumbpt\"" );
  reply.out() << _tntChunks[49]; // \n      />\n      </div>\n     
#line 413 "recordings.ecpp"
 } 
  reply.out() << _tntChunks[50]; // \n    <div class="recording_spec">\n      <div class="recording_name
#line 415 "recordings.ecpp"
  reply.sout() << ( (newR ? "_new" : "") );
  reply.out() << _tntChunks[51]; // ">
#line 415 "recordings.ecpp"
  reply.sout() << ( recItem->Name() );
  reply.out() << _tntChunks[52]; // </div>\n    </div>\n    <div class="recording_actions">&nbsp;</div>\n    </div>\n\n    
#line 420 "recordings.ecpp"

    std::string combinedId = recItem->Name() + "_";
    combinedId += counter + "_" + recItem->Level();
    std::string idHash(MD5Hash(combinedId));
    iRecItem = (uintptr_t)&recItem;
    
  reply.out() << _tntChunks[53]; //           <ul id="fldr_
#line 426 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[54]; // " class="recordingslist" style="display: none;">\n    
  // <& recordings.recordings_item ...
  { 
#line 427 "recordings.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 427 "recordings.ecpp"
    _tnt_cq7.add( "counter", (counter));
#line 427 "recordings.ecpp"
    _tnt_cq7.add( "filter", (filter));
#line 427 "recordings.ecpp"
    _tnt_cq7.add( "iRecItem", (iRecItem));
#line 427 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "recordings_item"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[55]; // \n                    </ul>\n            </li>\n    
#line 430 "recordings.ecpp"

  } // end of loop over subdirs
// now the items
  recItems.clear();
  sorted = recItemThisDir->addRecordings(recItems);
  level = recItemThisDir->Level() + 1;
} else {
// here we prepare the items in case of a flat list, no folders
  if (currentSort != "duplicates") recordingsTree->addAllRecordings(recItems);
}
argList.clear();
argList.append("&sort=");
argList.append(currentSort);
argList.append("&filter=");
argList.append(currentFilter);
if (currentSort != "duplicates") {
  if (!sorted) {
    if (currentSort == "dateasc")
            recItems.sort(RecordingsItemPtrCompare::ByAscendingDate);
    else if (currentSort == "datedesc")
            recItems.sort(RecordingsItemPtrCompare::ByDescendingDate);
    else if (currentSort == "namedesc")
            recItems.sort(RecordingsItemPtrCompare::ByDescendingNameDescSort);
    else if (currentSort == "nameasc")
            recItems.sort(RecordingsItemPtrCompare::ByAscendingNameDescSort);
    else if (currentSort == "errorsasc" || currentSort == "errorsdesc")
            recItems.sort(RecordingsItemPtrCompare::ByDescendingRecordingErrors);
  }

  bool first = true;
  bool displayFolder = currentFlat == "true";
  
  reply.out() << _tntChunks[56]; //   <script>Recordings(
#line 462 "recordings.ecpp"
  reply.sout() << (level);
  reply.out() << _tntChunks[57]; // , "
#line 462 "recordings.ecpp"
  reply.sout() << (argList);
  reply.out() << _tntChunks[58]; // ", 
#line 462 "recordings.ecpp"
  reply.sout() << (displayFolder?1:0);
  reply.out() << _tntChunks[59]; // , [\n    
#line 463 "recordings.ecpp"

    recoring_item.clear();
    RecordingsItemRec::AppendAsJSArray(recoring_item, recItems.begin(), recItems.end(), first, filter, displayFolder);
  // max_length_recoring_item = std::max(max_length_recoring_item, recoring_item.length() );
    
  reply.out() << _tntChunks[60]; //     
#line 468 "recordings.ecpp"
  reply.out() << ( recoring_item );
  reply.out() << _tntChunks[61]; // \n  ])</script>\n  
#line 470 "recordings.ecpp"
 } else {
// duplicates
  for (int i = 0; i < 3; i++) {
    recItems.clear();
    bool first = true;
    std::string nodeName;
    if (i == 0) {
      addDuplicateRecordingsSd(recItems, recordingsTree);
      nodeName = tr("Duplicates identified by tvscraper");
    } else if (i == 1) {
      addDuplicateRecordingsLang(recItems, recordingsTree);
      nodeName = tr("Duplicates, with different languages");
    } else if (i == 2) {
      addDuplicateRecordingsNoSd(recItems, recordingsTree);
      nodeName = tr("Duplicates not identified by tvscraper");
    }
    std::string idHash(MD5Hash(nodeName + "_1"));
    if (!recItems.empty() ) {
  
  reply.out() << _tntChunks[62]; //       <li class="recording">\n      <div class="recording_item" onclick="Toggle(this)">\n      <div class="recording_imgs">\n      <img class="recording_expander" src="
#line 492 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[63]; // plus.png" /><img class="recording_folder" src="
#line 492 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[64]; // folder_closed.png" /></div>\n      <div class="recording_spec">\n        <div class="recording_name">
#line 494 "recordings.ecpp"
  reply.sout() << ( nodeName );
  reply.out() << _tntChunks[65]; // </div>\n      </div>\n      <div class="recording_actions">&nbsp;</div>\n      </div>\n        <ul id="fldr_
#line 498 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[66]; // " class="recordingslist" style="display: none;">\n          <script>Recordings(1, "
#line 499 "recordings.ecpp"
  reply.sout() << (argList);
  reply.out() << _tntChunks[67]; // ", 1, [\n            
#line 500 "recordings.ecpp"

            recoring_item.clear();
            RecordingsItemRec::AppendAsJSArray(recoring_item, recItems.begin(), recItems.end(), first, filter, true);
            
  reply.out() << _tntChunks[68]; //             
#line 504 "recordings.ecpp"
  reply.out() << ( recoring_item );
  reply.out() << _tntChunks[69]; // \n          ])</script>\n        </ul>\n      </li>\n      
#line 508 "recordings.ecpp"

    }
  }
}
  
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::sort_options_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::sort_options " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 32 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 37 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 38 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 39 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 40 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 518 "recordings.ecpp"
 { 
  reply.out() << _tntChunks[72]; // <span class="label bold">
#line 519 "recordings.ecpp"
  reply.sout() << ( tr("Sort:") );
  reply.out() << _tntChunks[73]; //  </span>\n<a href="recordings.html\?sort=name&filter=
#line 520 "recordings.ecpp"
  if ( currentFilter != "" )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[74]; // " />
#line 520 "recordings.ecpp"
  reply.sout() << ( tr("Name") );
  reply.out() << _tntChunks[75]; // </a>\n<span class="sep">|</span>\n<a href="recordings.html\?sort=date&filter=
#line 522 "recordings.ecpp"
  if ( currentFilter != "" )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[76]; // " />
#line 522 "recordings.ecpp"
  reply.sout() << ( tr("Date") );
  reply.out() << _tntChunks[77]; // </a>\n<span class="sep">|</span>\n<a href="recordings.html\?sort=duplicates&filter=
#line 524 "recordings.ecpp"
  if ( currentFilter != "" )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[78]; // " />
#line 524 "recordings.ecpp"
  reply.sout() << ( tr("Duplicates") );
  reply.out() << _tntChunks[79]; // </a>\n
#line 525 "recordings.ecpp"

#if VDRVERSNUM >= 20505

  reply.out() << _tntChunks[80]; // <span class="sep">|</span>\n<a href="recordings.html\?sort=errors&filter=
#line 529 "recordings.ecpp"
  if ( currentFilter != "" )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[81]; // " />
#line 529 "recordings.ecpp"
  reply.sout() << ( tr("Errors") );
  reply.out() << _tntChunks[82]; // </a>\n
#line 530 "recordings.ecpp"

#endif
#ifdef HAVE_PCRE2

  reply.out() << _tntChunks[83]; // <span class="sep">|</span>\n<span class="label bold">
#line 535 "recordings.ecpp"
  reply.sout() << ( tr("Filter") );
  reply.out() << _tntChunks[84]; // :&nbsp;<input type="text" name="filter" value="
#line 535 "recordings.ecpp"
  reply.sout() << ( currentFilter );
  reply.out() << _tntChunks[85]; // " id="filter" onchange="filterRecordings(this)" />&nbsp;
  // <& tooltip.help ...
  { 
#line 535 "recordings.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 535 "recordings.ecpp"
    _tnt_cq8.add( "text", (tr("Look in recordings titles and subtitles for the given string and display only the matching ones. You may also use perl compatible regular expressions (PCRE).")));
#line 535 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "help"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[86]; // </span>\n
#line 536 "recordings.ecpp"

#endif

  reply.out() << _tntChunks[87]; // <span class="sep">|</span>\n<img onclick="ExpandAll()" src="
#line 540 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "plus.png") );
  reply.out() << _tntChunks[88]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 540 "recordings.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 540 "recordings.ecpp"
    _tnt_cq9.add( "text", (tr("Expand all folders")));
#line 540 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << _tntChunks[89]; // />\n<img onclick="CollapseAll()" src="
#line 541 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "minus.png") );
  reply.out() << _tntChunks[90]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 541 "recordings.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 541 "recordings.ecpp"
    _tnt_cq10.add( "text", (tr("Collapse all folders")));
#line 541 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << _tntChunks[91]; // />\n<br />\n
#line 543 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::del_rec_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::del_rec " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
  // </%args>

#line 32 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 37 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 38 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 39 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 40 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 552 "recordings.ecpp"
 { 
  reply.out() << _tntChunks[94]; // <a href="recordings.html\?todel=
#line 552 "recordings.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[95]; // " 
  // <& tooltip.hint ...
  { 
#line 552 "recordings.ecpp"
    tnt::QueryParams _tnt_cq11;
#line 552 "recordings.ecpp"
    _tnt_cq11.add( "text", (tr("Delete this recording from hard disc!")));
#line 552 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << _tntChunks[96]; // ><img src="
#line 552 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "del.png") );
  reply.out() << _tntChunks[97]; // " alt="" /></a>
#line 552 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::edit_rec_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::edit_rec " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
  // </%args>

#line 32 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 37 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 38 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 39 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 40 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 561 "recordings.ecpp"
 { 
  reply.out() << _tntChunks[100]; // <a href="edit_recording.html\?recid=
#line 561 "recordings.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[101]; // "><img src="
#line 561 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "edit.png") );
  reply.out() << _tntChunks[102]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 561 "recordings.ecpp"
    tnt::QueryParams _tnt_cq12;
#line 561 "recordings.ecpp"
    _tnt_cq12.add( "text", (tr("Edit recording")));
#line 561 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq12);
    // &>
  }
  reply.out() << _tntChunks[103]; //  /></a>
#line 561 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::rec_tools_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::rec_tools " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
std::string title = qparam.get< std::string >("title");
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
  // </%args>

#line 32 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 37 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 38 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 39 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 40 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <& pageelems.ajax_action_href ...
  { 
#line 573 "recordings.ecpp"
    tnt::QueryParams _tnt_cq13;
#line 573 "recordings.ecpp"
    _tnt_cq13.add( "action", "play_recording");
#line 573 "recordings.ecpp"
    _tnt_cq13.add( "alt", "");
#line 573 "recordings.ecpp"
    _tnt_cq13.add( "image", "play.png");
#line 573 "recordings.ecpp"
    _tnt_cq13.add( "param", (id));
#line 573 "recordings.ecpp"
    _tnt_cq13.add( "tip", (tr("play this recording.")));
#line 573 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq13);
    // &>
  }
  reply.out() << _tntChunks[106]; // \n
  // <& pageelems.m3u_playlist_recording ...
  { 
#line 574 "recordings.ecpp"
    tnt::QueryParams _tnt_cq14;
#line 574 "recordings.ecpp"
    _tnt_cq14.add( "recid", (id));
#line 574 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "m3u_playlist_recording"), request, reply, _tnt_cq14);
    // &>
  }
  reply.out() << _tntChunks[107]; // \n
  // <& pageelems.imdb_info_href ...
  { 
#line 575 "recordings.ecpp"
    tnt::QueryParams _tnt_cq15;
#line 575 "recordings.ecpp"
    _tnt_cq15.add( "s_IMDB_ID", (s_IMDB_ID));
#line 575 "recordings.ecpp"
    _tnt_cq15.add( "title", (title));
#line 575 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq15);
    // &>
  }
  reply.out() << _tntChunks[108]; // \n
  // <& recordings.edit_rec ...
  { 
#line 576 "recordings.ecpp"
    tnt::QueryParams _tnt_cq16;
#line 576 "recordings.ecpp"
    _tnt_cq16.add( "id", (id));
#line 576 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "edit_rec"), request, reply, _tnt_cq16);
    // &>
  }
  reply.out() << _tntChunks[109]; // \n
  // <& recordings.del_rec ...
  { 
#line 577 "recordings.ecpp"
    tnt::QueryParams _tnt_cq17;
#line 577 "recordings.ecpp"
    _tnt_cq17.add( "id", (id));
#line 577 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "del_rec"), request, reply, _tnt_cq17);
    // &>
  }
  reply.out() << _tntChunks[110]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::archived_disc_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::archived_disc " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string archived = qparam.get< std::string >("archived");
std::string title = qparam.get< std::string >("title");
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
  // </%args>

#line 32 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 37 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 38 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 39 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 40 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[113]; // <img src="
#line 588 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "on_dvd.png") );
  reply.out() << _tntChunks[114]; // " alt="on_dvd" 
  // <& tooltip.hint ...
  { 
#line 588 "recordings.ecpp"
    tnt::QueryParams _tnt_cq18;
#line 588 "recordings.ecpp"
    _tnt_cq18.add( "text", (archived));
#line 588 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq18);
    // &>
  }
  reply.out() << _tntChunks[115]; //  />\n
  // <& pageelems.imdb_info_href ...
  { 
#line 589 "recordings.ecpp"
    tnt::QueryParams _tnt_cq19;
#line 589 "recordings.ecpp"
    _tnt_cq19.add( "s_IMDB_ID", (s_IMDB_ID));
#line 589 "recordings.ecpp"
    _tnt_cq19.add( "title", (title));
#line 589 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq19);
    // &>
  }
  reply.out() << _tntChunks[116]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::delete_error_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::delete_error " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 32 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 37 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 38 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 39 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 40 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <& recordings.sort_options ...
  { 
#line 597 "recordings.ecpp"
    tnt::QueryParams _tnt_cq20;
#line 597 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "sort_options"), request, reply, _tnt_cq20);
    // &>
  }
  reply.out() << _tntChunks[120]; // \n
#line 598 "recordings.ecpp"
 { reply.out() << deleteResult; } 
  // <%/cpp>
  return DEFAULT;
}

} // namespace
